# Script 7.3 - ducks.rb

# Very basic Rectangle definition:
class Rectangle

  attr_reader :height, :width

  def initialize(h, w)
    @height, @width = h, w
  end

  def area
    @height * @width
  end
  
  # + should only work with other Rectangles!
  def +(rh)
    return nil unless rh.instance_of? Rectangle
    @height += rh.height
    @width += rh.width
    self
  end
  
  # Comparison can be with any object that
  # has an "area" method.
  def <=>(rh)
    return nil unless rh.respond_to?('area')
    if (self.area < rh.area) then -1
    elsif (self.area > rh.area) then 1
    else 0 end
  end
  
end # End of Rectangle class.

# Simple Circle definition:
class Circle
  attr_reader :radius
  def initialize(r)
    @radius = r
  end
  def area
    Math::PI * @radius**2
  end
end # End of Circle class.

# Create the objects:
r = Rectangle.new(32, 56)
c = Circle.new(8.4)

# Print their info:
puts "The area of r is #{r.area}. The area of c is #{c.area}."

# Print addition:
print "The addition of r + c: "
puts r + c 

# Print comparison:
print "The comparison of r and c: "
puts r <=> c

