# Script 7.2 - groceries.rb

# Define a new class:
class GroceryList

  # Constructor just creates a new hash.
  def initialize
    @items = Hash.new
  end
  
  # Method for adding items to the list.
  # The quantity value is optional, with a default value of 1.
  # The item's name is used as the key.
  def add(item, qty = 1)
    @items[item] = qty
  end
  
  # Method for iterating through the list.
  # Yields the key and the value.
  def each
    @items.each_pair { |k, v| yield k, v }
  end
  
  def to_s
  	str = ''
    @items.each_pair { |k, v| str += "#{k}: #{v}, "}
    str.slice(0, str.length - 2).to_s
  end
  
end # End of GroceryList class.

# Create a new list:
g = GroceryList.new

# Add some items:
g.add('sugar', '5 lbs')
g.add('kiwis', 4)
g.add('steak')

# Print the list as a string:
puts "List as a string => " + g.to_s

# Print the list with each item on its own line:
puts "Grocery List"
g.each { |item, qty| puts "#{qty} of #{item}" }