# Script 9.2 - mixin.rb

# Define the Circle class:
class Circle

  # Include Comparable mixin:
  include Comparable
  
  # Accessor for the radius:
  attr_reader :radius
  
  # initialize method sets the radius:
  def initialize(r)
    @radius = r
  end
  
  # Define the comparison operator:
  def <=>(rh)
    @radius <=> rh.radius
  end

end # End of Circle class.

# Create four circles:
c1 = Circle.new(8)
c2 = Circle.new(5)
c3 = Circle.new(8)
c4 = Circle.new(6)

# Print some comparisons:
puts "c1 is greater than or equal to c2: #{c1 >= c2}"
puts "c1 is equal to c3: #{c1 == c3}"
puts "c4 is between c2 and c1: #{c4.between?(c2, c1)}"
