# Script 11.4 - circle.rb

# Define the Circle class:
class Circle

  # Include Comparable mixin:
  include Comparable
  
  # Accessors for the radius:
  attr_reader :radius
  
  # initialize method sets the radius:
  def initialize(r = '')
  
    # Radius must be a positive number:
    raise ArgumentError.new('The radius must be a positive number.') unless (r.is_a? Numeric) && (r > 0)

    @radius = r
  end
  
  # Define the comparison operator:
  def <=>(rh)
    raise TypeError.new('Both objects must be Circles.') unless rh.is_a? Circle
    @radius <=> rh.radius
  end

end # End of Circle class.