# Script 11.5 - circles3.rb

# Require the Circle library:
require 'circle'

# Start a block:
begin

  # Create three circles and a string:
  c1 = Circle.new(5)
  c2 = Circle.new(2)
  c3 = Circle.new(-23.45)
  c4 = 'Hello, World!'

  # Print a comparison:
  puts "c1 is greater than or equal to c2: #{c1 >= c2}"
  
  # Print an invalid comparison:
  puts "c2 is between c1 and c4: #{c2.between?(c1, c4)}"

# Catch any exceptions:
rescue ArgumentError => e
  puts "A method was misused. Ruby reported: #{e}"
  
rescue NameError => e
  puts "You are attempting to use a class or method that does not exist. Check your spelling and any applicable documentation. Ruby reported: #{e}"

rescue TypeError => e
  puts "You are using an invalid type somehow. Ruby reported: #{e}"
  
rescue => e
  puts "Some other exception occurred. Ruby reported: #{e}"
  
end