# Script 12.2 - employees.rb

# Include the gem:
require 'rubygems'
require 'Highline/import'

# Define the module:
module Employees

  # Method that gets the process started:
  def Employees.start
    Employees.create_menu
  end

  # Method that creates the menu of options:
  def Employees.create_menu
  
    # Add a spacer:
    puts '---------------------'
    
    # Create the menu:
    choose do |m|
      m.prompt = 'Select an option: '
      m.choice(:'Add an Employee') { Employees.add_employee }
      m.choice(:'View All Employees') { Employees.view_employees }
      m.choice(:'Exit') { Process.exit }
    end
    
  end # End of create_menu

  # Method for adding employees:
  def Employees.add_employee
  
    # Add a spacer:
    puts '---------------------'
    
    # Get the info:
    fname = ask('First Name? ') { |q| q.validate = /\A[a-z .'-]+\Z/i }
    lname = ask('Last Name? ') { |q| q.validate = /\A[a-z .'-]+\Z/i }
    id = ask('Employee ID? ', Integer) { |q| q.above = 0 }
    
    # See if they want to add another:
  	Employees.add_employee if agree('Add Another? ')
  	
  	# Create the menu:
  	Employees.create_menu
  	
  end # End of add_employee
  
  # Method for viewing employees:
  def Employees.view_employees
  
    # Add a spacer:
    puts '---------------------'
    
    puts 'Here is where you would see all the employees.'
    Employees.create_menu
  end
  
end # End of Employees module.

# Start the ball rolling:
Employees.start
