# Script 13.2 - lost.rb

# Define the class:
class Lost

  # Include the gem:
  require 'rubygems'
  require 'Highline/import'

  # Need a getter for the file pointer:
  attr_reader :fp

  # Constructor opens the file:
  def initialize(file)
    @fp = File.open(file, 'a')
  end

  # Method for adding records:
  def add_record
  
    # Get the info:
    name = ask('Name? ') { |q| q.validate = /\A[a-z .'-]+\Z/i }
    id = ask('ID? ', Integer) { |q| q.above = 0 }

    # Write the data to the file:
    @fp.puts "#{id},#{name}"

  end # End of add_record
  
  # Method for closing the file:
  def close
    @fp.close
  end
  
end # End of Lost class.

# Create the object:
lost = Lost.new('data.txt')

# Add two more records:
2.times { lost.add_record }

# Close the file:
lost.close
