# Script 13.3 - lost2.rb

# Define the class:
class Lost

  # Include the gems:
  require 'rubygems'
  require 'Highline/import'
  require 'fastercsv'

  # Create the getters:
  attr_reader :file

  # Constructor opens the file:
  def initialize(file)
    @file = file
  end

  # Method for adding records:
  def add_record
  
    # Get the info:
    name = ask('Name? ') { |q| q.validate = /\A[a-z ,.'-]+\Z/i }
    id = ask('ID? ', Integer) { |q| q.above = 0 }

    # Write the data to the file:
    FasterCSV.open(file, 'a') do |fp|
      fp << [id, name]
	end

  end # End of add_record
  
  # Method for returning records:
  def each
  
  	FasterCSV.foreach(file) do |record|
  	  yield record[0], record[1]
  	end
  
  end
  
end # End of Lost class.

# Create the object:
lost = Lost.new('data.txt')

# Add two more records:
2.times { lost.add_record }

# Print each record:
lost.each do |num, name| 
  puts "#{name} (#{num})"
end
