# Script 17.5 - lambdas.rb

# Method that returns a lambda:
def return_power_lambda(power)
  lambda { |x| x ** power }
end

# Create two lambdas:
squared = return_power_lambda(2)
cubed = return_power_lambda(3)

# Apply the lambdas to some numbers:
2.upto(10) do |n|
  puts "#{n} squared is #{squared.call(n)}"
  puts "#{n} cubed is #{cubed.call(n)}"
end